%global _hardened_build 1
# exclude devel(libocsync)
%define _requires_exceptions devel(libocsync(64bit))\\|devel(libqt5keychain(64bit))

%define _cmake_skip_rpath %nil
%define libocsync_major 0
%define liblibocsync %mklibname ocsync %libocsync_major
%define nextcloudsync_major 0
%define libnextcloudsync %mklibname nextcloudsync %nextcloudsync_major
%define develname %mklibname %{name} -d

Name:           nextcloud-client
Version:        2.2.4
Release:        %mkrel 2
Summary:        The Nextcloud Client
Group:          Networking/File transfer
License:        LGPLv2+ and GPLv2
Url:            https://nextcloud.com/install/#install-clients
Source0:        https://github.com/nextcloud/client_theming/archive/v%{version}.tar.xz
Source1:        https://download.owncloud.com/desktop/stable/owncloudclient-%{version}.tar.xz
Source2:        %{name}.appdata.xml
Patch0:         %{name}-2.2.3-syslibs.patch
Patch1:         %{name}-2.2.4-appshortname.patch
#--------------------------------------------------
BuildRequires:  cmake
BuildRequires:  desktop-file-utils
BuildRequires:  doxygen
BuildRequires:  libneon-devel
BuildRequires:  libopenssl-devel
BuildRequires:  python-sphinx
BuildRequires:  appstream-util

BuildRequires: kf5-macros
BuildRequires: libkcoreaddons-devel
BuildRequires: libkio-devel
BuildRequires: libopenssl-devel
BuildRequires: libqt5concurrent-devel
BuildRequires: libqt5core-devel
BuildRequires: libqt5dbus-devel
BuildRequires: libqt5gui-devel
BuildRequires: libqt5keychain-devel
BuildRequires: libqt5network-devel
BuildRequires: libqt5webkit-devel
BuildRequires: libqt5webkitwidgets-devel
BuildRequires: libqt5widgets-devel
BuildRequires: libqt5xml-devel
BuildRequires: libqtsingleapplication-qt5-devel
BuildRequires: libsqlite3-devel
BuildRequires: mesa-devel
BuildRequires: qtbase5-common-devel
BuildRequires: qttools5
BuildRequires: zlib1-devel
#--------------------------------------------------
Provides:       owncloud-client = %version-%release
Obsoletes:      owncloud-client

%description
Nextcloud-client enables you to connect to your private Nextcloud Server.
With it you can create folders in your home directory, and keep the contents
of those folders synced with your Nextcloud server. Simply copy a file into
the directory and the Nextcloud Client does the rest.

%files
%{_bindir}/nextcloud
%{_bindir}/nextcloudcmd
%{_datadir}/applications/nextcloud.desktop
%dir %{_datadir}/nextcloud
%{_datadir}/nextcloud/i18n/
%{_datadir}/icons/hicolor/*/apps/*
%{_datadir}/appdata/%{name}.appdata.xml
%dir %{_sysconfdir}/Nextcloud
%{_sysconfdir}/Nextcloud/sync-exclude.lst
#------------------------------------------------------------------------------
%{_libdir}/libnextcloudsync.so.%nextcloudsync_major
%{_libdir}/libnextcloudsync.so.%version
#------------------------------------------------------------------------------
%dir %_libdir/nextcloud
%_libdir/nextcloud/libocsync.so.%{libocsync_major}
%_libdir/nextcloud/libocsync.so.%{version}
#------------------------------------------------------------------------------

%package dolphin
Summary:        Dolphin overlay icons
Group:			Graphical desktop/KDE5
Requires:       dolphin
Requires:       %{name} = %{version}-%{release}

%description dolphin
The nextcloud desktop client dolphin extension.

%files dolphin
%{_kf5_libdir}/libnextclouddolphinpluginhelper.so
%{_kf5_plugindir}/overlayicon/nextclouddolphinoverlayplugin.so
%{_qt5_plugindir}/nextclouddolphinactionplugin.so
%{_kf5_services}/nextclouddolphinactionplugin.desktop

#------------------------------------------------------------------------------

%package -n %{develname}
Summary:        Development files for nextcloud-client
Group:			Development/Libraries
License:        LGPLv2+
Provides:       %{name}-static = %{version}-%{release}
Provides:       %{name}-devel = %{version}-%{release}
Obsoletes:      %{name}-devel
# From owncloud-client
Obsoletes:      %{_lib}owncloud-client-devel

%description -n %{develname}
Development headers for use of the nextcloud-client library.

%files -n %{develname}
%{_libdir}/libnextcloudsync.so
%{_includedir}/nextcloudsync/
%{_libdir}/libnextcloudsync.so
%{_libdir}/nextcloud/libocsync.so

#------------------------------------------------------------------------------

%prep
%setup -q -n client_theming-%{version}
%setup -T -D -a 1 -n client_theming-%{version}
rm -Rf client
mv owncloudclient-%{version} client
%patch0 -p1
%patch1 -p1
rm -rf src/3rdparty/qtlockedfile src/3rdparty/qtsingleapplication

# fix nextcloud desktop icon name (mga#19473#c6)
sed -i 's/^\(Icon\(\[.*\]\)*=\).*$/\1@APPLICATION_NAME@/' client/mirall.desktop.in

%build
#see https://www.openssl.org/docs/manmaster/crypto/OpenSSL_add_all_algorithms.html
sed -i "s#SSLeay_add_all_algorithms#//OPENSSL_init_crypto#g" client/src/3rdparty/certificates/p12topem.cpp

%cmake_kf5 \
        -DCMAKE_SHARED_LINKER_FLAGS="-Wl,--as-needed" \
        -DOEM_THEME_DIR=`pwd`/../nextcloudtheme ../client
%make


%install
rm -rf %buildroot
%make_install -C build

%find_lang client
mkdir -p %{buildroot}%{_datadir}/appdata/
install -m 644 %{SOURCE2} %{buildroot}%{_datadir}/appdata/%{name}.appdata.xml

rm -rf %{buildroot}/%{_datadir}/nautilus-python/extensions
rm -rf %{buildroot}/%{_datadir}/nemo-python/extensions

%check
appstream-util validate-relax --nonet %{buildroot}%{_datadir}/appdata/%{name}.appdata.xml

desktop-file-install --vendor="" \
  --remove-category="Application" \
  --remove-category="X-SuSE-SyncUtility" \
  --add-category="X-MandrivaLinux-Internet-FileTransfer" \
  --dir $RPM_BUILD_ROOT%{_datadir}/applications $RPM_BUILD_ROOT%{_datadir}/applications/*.desktop


%changelog
* Thu Apr 06 2017 adrianomorselli <adrianomorselli> 2.2.4-2uplos2017
- update
- fix req on devel package
